﻿class geneClass extends MovieClip
{
	//Version X11
	//This class handles various functions of lines (genes)
	//Includes scoring information
	//Includes the texts of line readings
	
	var myIndex: Number;
	var iter: Number = 0;
	var seqArray: Array;
	var tArray: Array;
	var lineLock: Boolean = false;
	var i: Number;
	var cycleLimit: Number;
	var lineOut: String;
	var textToGo: Boolean = false;
	var textCount: Number = 0;
	var textDelay: Number;
	
	//CYCLE LINE READINGS
	function onPress()
	{
		if(!lineLock && !textToGo)
		{
			if(myIndex < 2 || (myIndex > 0 && _root.codeOpen))
			{
				//reset repeat-request trigger (see hearBtnClass)
				_root.repRequest = false;
				
				iter ++;
				if(_root.lineOptions == "full")
				{
					cycleLimit = seqArray.length;
				}
				else
				{
					cycleLimit = 5;
				}
				if(iter == cycleLimit) iter = 0;
				
				//pull line reading from tArray
				lineOut = tArray[iter];
				
				textToGo = true;
				textDelay = getTimer()+75;
				_root["g_"+myIndex].line.text = "";

				//play code audible for this line
				_root.codeSound.audibilize(myIndex, iter);
			}
		}
	}
	
	//ENTERFRAME HANDLES PROGRESSIVE DELIVERY OF LINE TEXT
	function onEnterFrame()
	{
		if(textToGo)
		{
			if(getTimer() > textDelay)
			{
				textDelay = getTimer()+75;
				_root["g_"+myIndex].line.text += lineOut.charAt(textCount);
				textCount ++;
			}
			if(textCount == lineOut.length)
			{
				textToGo = false;
				textCount = 0;
			}
		}
	}

	//CODE OR CONSEQUENCES
	function perform()
	{
		switch(myIndex)
		{
			case 0:
				if(iter == 0)
				{
					_root.codeOpen = true;
					for(i = 0; i< 10; i++)
					{
						_root["btn_"+i]._visible = true;
					}
					_root.score +=50;
				}
				
				if(iter == 1)
				{
					_root.idiom = "ActionScript";
					_root.lineOptions = "full";
					_root.score +=100;
				}
				
				if(iter == 2)
				{
					_root.codeOpen = false;
					for(i = 1; i< 10; i++)
					{
						_root["btn_"+i]._visible = false;
						_root.endTime = getTimer()+5000;
						_root.score -=100;
					}
				}
				
				if(iter == 3)
				{
					_root.idiom = "Pseudocode";
					_root.lineOptions = "default";
					_root.score +=10;
				}
				
				if(iter > 3) _root.score -=10; //comments
				
				break;
				// end case 0
				
			case 1:
				if(iter == 0)
				{
					_root.codeOpen = true;
					for(i = 0; i< 10; i++)
					{
						_root["btn_"+i]._visible = true;
					}
					_root.score += 50;
				}
				
				if(iter == 1)
				{
					_root.idiom = "ActionScript";
					_root.lineOptions = "full";
					_root.score =+ 100;
				}
				
				if(iter == 2)
				{
					_root.endTime = getTimer()+6000;
					_root.score -=50;
				}
				
				if(iter == 3)
				{
					_root.codeOpen = false;
					for(i = 0; i< 10; i++)
					{
						_root["btn_"+i]._visible = false;
					}
					_root.endTime = getTimer()+5000;
					_root.score -=100;
				}
				
				if(iter == 4)
				{
					_root.lineOptions = "full";
					_root.score +=100;
				}
				
				if(iter > 5) _root.score -=10; //last three are comments
				
				break;
				//end gene 1
				
			case 2:
				if(iter == 0) 
				{
					_root.endTime = getTimer();
					_root.score -=50;
				}
				
				if(iter == 1)
				{
					_root.endTime = getTimer()+75000;
					_root.score -=10;
				}
				
				if(iter == 2)
				{
					_root.endTime = getTimer()+_root.maxValue;
					_root.score +=100;
				}
				
				if(iter == 3) 
				{
					_root.lineOptions = "default";
					_root.score -=10;
				}
				
				if(iter == 4)
				{
					_root.endTime = getTimer()+180000;
					_root.score -10;
				}
				
				if(iter == 5)
				{
					_root.endTime = getTimer()+8000;
					_root.score -=50;
				}
				
				if(iter == 6)
				{
					_root.idiom = "Pseudocode";
					_root.lineOptions = "default";
					_root.score +=10;
				}
				
				if(iter == 7) _root.score -=10 //comment
				
				break; //end gene 2
				
			case 3:
				if(iter == 0)
				{
					_root.codeSound.myVol = 0;
					_root.score -=100;
				}
				
				if(iter == 1)
				{
					_root.endTime = Math.random()*300;
					_root.score -=50;
				}
				
				if(iter == 2)
				{
					_root.codeSound.myVol = 100;
					_root.score +=50;
				}
				
				if(iter == 3)
				{
					_root.codeSound.myVol = 200;
					_root.score +=100;
				}
				
				if(iter == 4) _root.score -=10 //comment
				
				if(iter == 5)
				{
					_root.codeSound.myVol = 50;
					_root.score -=10;
				}
				
				if(iter == 6) _root.score -=10 //comment
				
				if(iter == 7)
				{
					_root.idiom = "ActionScript";
					_root.lineOptions = "full";
					_root.score +=50;
				}
				
				break;  //end gene 3
				
			case 4:
				if(iter == 0)
				{
					_root.ambientSound.howLoud = 75;
					_root.ambientSound.reSound();
					_root.score +=10;
				}
				
				if(iter == 1) _root.score -=10 // comment
				
				if(iter == 2) _root.score -=10 //comment

				if(iter == 3)
				{
					_root.ambientSound.howLoud = 150;
					_root.ambientSound.reSound();
					_root.score -=50;
				}
				
				if(iter == 4) 
				{
					_root.ambientSound.howLoud = 0;
					_root.ambientSound.reSound();
					_root.score +=50;
				}
				
				if(iter == 5)
				{
					_root.mainGraphic.imgHolder.loadMovie("images/mainGFk_"+_root.idiom.charAt(0)+"-"+iter+".jpg");
					_root.mainGraphic._alpha = 100;
					_root.score +=100;
				}
				
				if(iter == 6) _root.score -=10 //comment
				
				if(iter == 7)
				{
					_root.ambientSound.howLoud = 200;
					_root.ambientSound.reSound();
					_root.score -=100;
				}
				
				break;  //end gene 4
				
			case 5:
				//poetry makes nothing happen:
				//the "primary metaphor" is a fiction; no scoring consequences
				break; //end gene 5
				
			case 6:
				if(iter == 0)
				{
					_root.endTime = _root.maxValue;
					_root.score +=10;
				}
				
				if(iter == 1)
				{
					_root.mainGraphic.imgHolder.loadMovie("images/mainGFk_"+_root.idiom.charAt(0)+"-"+iter+".jpg");
					_root.mainGraphic._alpha = Math.random()*100;
					_root.score +=10;
				}
				
				if(iter == 2)
				{
					_root.mainGraphic.imgHolder.loadMovie("images/mainGFk_"+_root.idiom.charAt(0)+"-"+iter+".jpg");
					_root.mainGraphic._alpha = 100;
					_root.score +=100;
				}
				
				if(iter == 3)
				{
					_root.mainGraphic.imgHolder.loadMovie("images/mainGFk_"+_root.idiom.charAt(0)+"-"+iter+".jpg");
					_root.mainGraphic._alpha = 50;
					_root.score +=50;
				}
				
				if(iter == 4) _root.score -=10 //comment
				
				if(iter == 5) _root.score -=10 //comment
				
				if(iter == 6)
				{
					_root.idiom = "Pseudocode";
					_root.lineOptions = "default";
					_root.score +=10;
				}
				
				if(iter == 7) _root.score -=10 //comment
				
				break;  //end gene 6
				
			case 7:
				if(iter == 0) 
				{
					_root.mainGraphic.sequence = 4;
					_root.score +=10;
				}
				
				if(iter == 1) _root.score -=10 // comment
				
				if(iter == 2) _root.score -=10 //comment
				
				if(iter == 3)
				{
					_root.mainGraphic.sequence = 0;
					_root.score -50;
				}
				
				if(iter == 4)
				{
					_root.mainGraphic.sequence = Math.floor(Math.random()*8);
					_root.score +=10;
				}
				
				if(iter == 5) _root.score -=10 //comment
				
				if(iter == 6)
				{
					_root.mainGraphic.sequence = 7;
					_root.score +=100;
				}
				
				if(iter == 7) _root.score -=10 //comment
				
				break;  //end gene 7
				
			case 8:
				_root.overlay._root.draw1.clear(); //force redraw of overlay anim
				_root.overlay._root.draw2.clear();
				
				if(iter == 0)
				{
					_root.overlay.xLimit = 250;
					_root.score +=100;
				}
				
				if(iter == 1) _root.score -=10 //comment
				
				if(iter == 2) _level0.loadMovie("main.swf");
				
				if(iter == 3)
				{
					_root.overlay.xLimit = 5000;
					_root.score +=50;
				}
				
				if(iter == 4) _root.score -=10 //comment
				
				if(iter == 5)
				{
					_root.ambientSound.howLoud = Math.random()*100;
					_root.score -=10;
				}
				
				if(iter == 6) _root.score -=10 //comment
				
				if(iter == 7)
				{
					_root.mainGraphic.sequence = 6;
					_root.score +=10;
				}
				
				break;  //end gene 8
				
			case 9:
				_root.overlay._root.draw1.clear();  //force redraw of overlay anim
				_root.overlay._root.draw2.clear();
				
				if(iter == 0)
				{
					_root.overlay.lineAlpha = 0;
					_root.score +=50;
				}
				
				if(iter == 1) _root.score *= 10; //BIG SCORE BONUS
				
				if(iter == 2) _root.score -=10 //comment
				
				if(iter == 3)
				{
					_root.overlay.lineAlpha = 100;
					_root.score -=10;
				}
				
				if(iter == 4) _root.score -=10 //comment
				
				if(iter == 5) _root.score = 0;
				
				if(iter == 6)
				{
					_root.overlay.lineAlpha = 15;
					_root.score +=100;
				}
				
				if(iter == 7) _root.score -=10 //comment
				
				break;  //end gene 9
		}
	}
	
	function geneClass()
	{
		//pull index number
		myIndex = Number(_name.charAt(_name.length - 1));
		//set position
		_x = 510;
		_y = 25+ myIndex * 50;
		
		//SET TEXT SEQUENCES
		//"Y" means pull line from text object; "z" means pull noise from Babel object
		switch(myIndex)
		{
			case 0:
				seqArray = new Array("Y","Y","Y","Y","z","z");
				tArray = new Array("Because these words are shadows","As we might say while dreaming","Although these words mean nothing","Because we share this language","For no particular reason","Despite the claims of reason");
				break;
			case 1:
				seqArray = new Array("Y","Y","Y","Y","Y","z","z","z");
				tArray = new Array("We can reach across the borders","We can see another order","We will not have time","Leave us our stable certainties","We will play all the angles","We sign our names at random","We call ourselves by vacant names","We say whatever comes to mind");
				break;
			case 2:
				seqArray = new Array("Y","Y","Y","Y","Y","Y","Y","z");
				tArray = new Array("Agreeing to say no more","Yielding to ourselves these moments","Taking all the time it needs","Considering only what is given","Pushing back a bit the end","Some short while before the end","Speaking in the common tongue","Saying whatever amounts to buzz");
				break;
			case 3:
				seqArray = new Array("Y","Y","Y","Y","z","Y","z","Y");
				tArray = new Array("While prone to silent disasters","Though subject to sudden fatality","Assuming we can hear ourselves","When we can hear ourselves think","While flying along tangents","Though the other voice is weak","While taking up the nothing","Speaking the language of form");
				break;
			case 4:
				seqArray = new Array("Y","z","z","Y","Y","Y","z","Y");
				tArray = new Array("Meanwhile humanity testifies","While somewhere something persists","While making a sign of meaning","Then the babble of everything rises","Then the babble falls away","Then we intersect the light","So the dream already commences","And so we bring the noise");
				break;
			case 5:
				seqArray = new Array("Y","Y","Y","Y","Y","z","z","z");
				tArray = new Array("So we choose our metaphors wisely","So we make our words with caution","So we make our vexed selections","So we reach the root of the matter","So we make a shape for knowing","So we engage our materiality","So we do the work of naming","So we spend our seconds wondering");
				break;
			case 6:
				seqArray = new Array("Y","Y","Y","Y","z","z","Y","z");
				tArray = new Array("Then let the time continue","Then show us something, maybe","Then let us proceed to showing","Then let us suggest appearances","And come to no conclusions","And reach no sense of ending","Then speak again familiar","And step across one more line");
				break;
			case 7:
				seqArray = new Array("Y","z","z","Y","Y","z","Y","z");
				tArray = new Array("And step off half the story","And let the noise continue","But make no claims of sanction","But do not depart or vary","And show what you can of the story","But have this to say about that","And show the whole strange story","But first consult the innocent");
				break;
			case 8:
				seqArray = new Array("Y","z","Y","Y","z","Y","z","Y");
				tArray = new Array("Constraining all geometries","Evading the improvisations of how","Deciding to reset the world","Setting free the geometries","Bathing in the radiance of being","Expecting a shout from the street","As one more stage unfolds","Casting aside the final stages");
				break;
			case 9:
				seqArray = new Array("Y","Y","z","Y","z","Y","Y","z");
				tArray = new Array("And so at last to see","And take the higher prize","And touch an inward truth","And hold the world in lines","And find a final word","Only to lose the game!","And see between the lines","With this, and nothing more");
				break;
			
		}

		//set initial text
		_root["g_"+myIndex].line.text = ". . . . . . . . . . . . . . . . . .";
		//hide text frame
		_root["g_"+myIndex].frame._alpha = 10;
		_root["g_"+myIndex].frame._visible = false;
		
		iter = Math.floor(Math.random()*5);
		
		//iter = -1;
		
	}
	
}