﻿class overlayClass extends MovieClip
{
	//vers X11
	
	var lineAlpha:Number = 50;
	
	var draw1:MovieClip;
	var draw2:MovieClip;
	
	var r:Number;
	var spotX:Number;
	var spotY: Number;
	var initX:Number;
	var initY:Number;
	var segs:Number = 16;
	var segAngle:Number;
	var controlDist:Number;
	var endX:Number;
	var endY:Number;
	var controlX:Number;
	var controlY:Number;
	var delay:Number;
	var numIts:Number;
	var its:Number;
	var firstRun: Boolean;;
	var xLimit: Number = 700;
	var fillMe: Boolean = false;
	
	function onEnterFrame()
	{
		if(getTimer()>delay)
		{
			makeShape();
			setDelay();
			its++;
			if(its > numIts)
			{
				setIterations();
			}
		}
	}
	
	function makeShape()
	{
		if(its%2 == 0) setLineStyle();
		
		r = 10+Math.floor(Math.random()*30);
		spotX = Math.floor(Math.random()*xLimit);
		spotY = Math.floor(Math.random()*500);
		
		if(Math.floor(Math.random()*3) == 1)_root.draw1.beginFill(Math.random()*0xFFFFFF, lineAlpha/2);
		
		//select and draw shape
		switch(Math.floor(Math.random()*3))
		{
			case 0:
				makeCircle();
				break;
			case 1:
				makeSquare();
				break;
			case 2:
				makeDiamond();
				break;		   
		}
		
		_root.draw1.endFill();
		
		//draw link line
		if(!firstRun)
		{
			_root.draw2.moveTo(initX, initY);
			_root.draw2.lineTo(spotX, spotY);
		}
		else
		{
			firstRun = false;
		}

		initX = spotX;
		initY = spotY;

	}
	
	function makeSquare()
	{
		_root.draw1.moveTo(spotX-r, spotY-r);
		_root.draw1.lineTo(spotX+r, spotY-r);
		_root.draw1.lineTo(spotX+r, spotY+r);
		_root.draw1.lineTo(spotX-r, spotY+r);
		_root.draw1.lineTo(spotX-r, spotY-r);
	}
	
	function makeDiamond()
	{
		_root.draw1.moveTo(spotX, spotY-r/2);
		_root.draw1.lineTo(spotX+r/2, spotY);
		_root.draw1.lineTo(spotX, spotY+r/2);
		_root.draw1.lineTo(spotX-r/2, spotY);
		_root.draw1.lineTo(spotX, spotY-r/2);
	}
	
	function makeCircle()
	{
		segAngle = (360/segs)/180 * Math.PI;
		controlDist = r/Math.cos(segAngle/2);
		_root.draw1.moveTo(spotX+r, spotY);

		for(var i:Number=0; i<=segs; i++)
		{
			endX = spotX + r * Math.cos(i*segAngle);
			endY = spotY - r * Math.sin(i*segAngle);
			controlX = spotX+controlDist * Math.cos(i*segAngle-segAngle/2);
			controlY = spotY-controlDist * Math.sin(i*segAngle-segAngle/2);
			_root.draw1.curveTo(controlX, controlY, endX, endY);
		}
	}
	
	function setLineStyle()
	{
		_root.draw1.lineStyle(2, Math.floor(Math.random()*0xFFFFFF), lineAlpha);
		_root.draw2.lineStyle(2, Math.floor(Math.random()*0xFFFFFF), lineAlpha);
	}
	
	function setDelay()
	{
		delay = getTimer()+300+Math.floor(Math.random()*1000);
	}
	
	function setIterations()
	{
		numIts = 8 + Math.floor(Math.random()*32);
		its = 0;
		_root.draw1.clear();
		_root.draw2.clear();
		firstRun = true;
	}

	function overlayClass()
	{
		_root.createEmptyMovieClip("draw1", 1);
		_root.createEmptyMovieClip("draw2", 2);
		
		setIterations();
		setDelay();
		setLineStyle();
	}
	
}